module Distance where

import Monad
import Array

import IOExts
import Word
import Foreign

import Board

foreign import ccall "calc_distance" c_calc_distance :: Ptr Word8
						     -> Ptr Int
						     -> Int
						     -> Int
						     -> Int
						     -> Int
						     -> Int
						     -> IO ()




data Distance = Dist Int Int (Ptr Word8) (Ptr Int)

new_distance (Board w h ptr) = do
    w32 <- mallocArray (w*h)
    return $ Dist w h ptr w32

-- distances for walking to the square
update_distance_to (Dist w h ptr w32) (x,y) = do
    c_calc_distance ptr w32 w h x y 0
    return ()

-- distances for walking from the square
update_distance_from (Dist w h ptr w32) (x,y) = do
    c_calc_distance ptr w32 w h x y 1
    return ()

free_distance (Dist _ _ _ w32) = do
    free w32
    return ()

dist_get (Dist w h ptr w32) (x,y)
    | x >= 1 && x <= w &&
      y >= 1 && y <= h = f
    | otherwise = error "Outside vector"
    where f = peekElemOff w32 ((x-1)+(y-1)*w)
